Skip to main content
GET
/
api
/
v1
/
automations
ListAutomations
package main

import(
	"context"
	"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
	conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
	"log"
)

func main() {
    ctx := context.Background()

    s := conductoronesdkgo.New(
        conductoronesdkgo.WithSecurity(shared.Security{
            BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
            Oauth: "<YOUR_OAUTH_HERE>",
        }),
    )

    res, err := s.Automation.ListAutomations(ctx)
    if err != nil {
        log.Fatal(err)
    }
    if res.ListAutomationsResponse != nil {
        // handle response
    }
}
import { ConductoroneSDKTypescript } from "conductorone-sdk-typescript";

const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
  security: {
    bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
    oauth: "<YOUR_OAUTH_HERE>",
  },
});

async function run() {
  const result = await conductoroneSDKTypescript.automation.listAutomations();

  console.log(result);
}

run();
curl --request GET \
  --url https://{tenantDomain}.conductor.one/api/v1/automations \
  --header 'Authorization: Bearer <token>'
import requests

url = "https://{tenantDomain}.conductor.one/api/v1/automations"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.text)
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

fetch('https://{tenantDomain}.conductor.one/api/v1/automations', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));


{
  "list": [
    {
      "annotations": {},
      "appId": "<string>",
      "automationSteps": [
        {
          "accountLifecycleAction": {
            "accountInContext": {},
            "accountRef": {
              "accountIdCel": "<string>"
            },
            "actionName": "<string>",
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            }
          },
          "callFunction": {
            "args": {},
            "functionId": "<string>"
          },
          "connectorAction": {
            "actionName": "<string>",
            "argsTemplate": {},
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            },
            "resourceTypeId": "<string>"
          },
          "connectorCreateAccount": {
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            },
            "passwordCel": "<string>",
            "userIdCel": "<string>",
            "userProperties": {
              "displayNameCel": "<string>",
              "emailCel": "<string>",
              "profileAttributeCel": "<string>",
              "usernameCel": "<string>"
            }
          },
          "createAccessReview": {
            "accessReviewTemplateCel": "<string>",
            "accessReviewTemplateId": "<string>",
            "campaignName": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "createRevokeTasks": {
            "appEntitlementRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "appEntitlementRefsCel": "<string>",
            "excludedAppEntitlementRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "excludedAppEntitlementRefsCel": "<string>",
            "revokeAll": true,
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "createRevokeTasksV2": {
            "exclusionCriteria": {
              "excludedAppIds": [
                "<string>"
              ],
              "excludedComplianceFrameworkIds": [
                "<string>"
              ],
              "excludedResourceTypeIds": [
                "<string>"
              ],
              "excludedRiskLevelIds": [
                "<string>"
              ]
            },
            "exclusionList": {
              "excludedAppEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "exclusionListCel": {
              "excludedAppEntitlementRefsCel": "<string>"
            },
            "exclusionNone": {},
            "inclusionAccessOnly": {},
            "inclusionAll": {},
            "inclusionCriteria": {
              "appIds": [
                "<string>"
              ],
              "complianceFrameworkIds": [
                "<string>"
              ],
              "resourceTypeIds": [
                "<string>"
              ],
              "riskLevelIds": [
                "<string>"
              ]
            },
            "inclusionList": {
              "appEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "inclusionListCel": {
              "appEntitlementRefsCel": "<string>"
            },
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "evaluateExpressions": {
            "expressions": [
              {
                "expressionCel": "<string>",
                "isSecret": true,
                "key": "<string>"
              }
            ]
          },
          "generatePassword": {
            "passwordPolicyId": "<string>",
            "policy": {
              "customCharacters": "<string>",
              "excludedCharacters": "<string>",
              "maxCharacterCount": 123,
              "minCharacterCount": 123,
              "noRestrictions": true,
              "requireLowercase": true,
              "requireNumbers": true,
              "requireSpecialCharacters": true,
              "requireUppercase": true
            }
          },
          "grantEntitlements": {
            "exclusionCriteria": {
              "excludedAppIds": [
                "<string>"
              ],
              "excludedComplianceFrameworkIds": [
                "<string>"
              ],
              "excludedRiskLevelIds": [
                "<string>"
              ]
            },
            "exclusionList": {
              "excludedAppEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "exclusionListCel": {
              "excludedAppEntitlementRefsCel": "<string>"
            },
            "exclusionNone": {},
            "inclusionCriteria": {
              "appIds": [
                "<string>"
              ],
              "complianceFrameworkIds": [
                "<string>"
              ],
              "riskLevelIds": [
                "<string>"
              ]
            },
            "inclusionList": {
              "appEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "inclusionListCel": {
              "appEntitlementRefsCel": "<string>"
            },
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "removeFromDelegation": {
            "replacementUserIdCel": "<string>",
            "replacementUserRef": {
              "id": "<string>"
            },
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "runAutomation": {
            "automationTemplateIdCel": "<string>",
            "automationTemplateRef": {
              "id": "<string>"
            },
            "context": {
              "context": {}
            }
          },
          "sendEmail": {
            "body": "<string>",
            "email": "<string>",
            "emailCel": "<string>",
            "subject": "<string>",
            "title": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "sendSlackMessage": {
            "body": "<string>",
            "channelName": "<string>",
            "channelNameCel": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "setCredential": {
            "accountIdCel": "<string>",
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            },
            "passwordCel": "<string>"
          },
          "skipIfTrueCel": "<string>",
          "stepDisplayName": "<string>",
          "stepName": "<string>",
          "storeCredential": {
            "appIdCel": "<string>",
            "credentialCel": "<string>",
            "expiry": "<string>",
            "labelCel": "<string>",
            "maxViews": 123,
            "recipientCel": "<string>",
            "recipientEmailCel": "<string>",
            "ttl": "<string>"
          },
          "taskAction": {
            "close": {
              "useSubjectUser": true,
              "userIdCel": "<string>",
              "userRef": {
                "id": "<string>"
              }
            },
            "reassign": {
              "assigneeUserIdCel": "<string>",
              "assigneeUserRef": {
                "id": "<string>"
              },
              "subjectUserIdCel": "<string>",
              "subjectUserRef": {
                "id": "<string>"
              },
              "useSubjectUser": true
            },
            "taskTypes": []
          },
          "unenrollFromAllAccessProfiles": {
            "catalogIds": [
              "<string>"
            ],
            "catalogIdsCel": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "updateUser": {
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            },
            "userStatusCel": "<string>"
          },
          "waitForDuration": {
            "duration": "<string>"
          },
          "webhook": {
            "payload": {},
            "webhookId": "<string>",
            "webhookIdCel": "<string>"
          }
        }
      ],
      "circuitBreaker": {
        "observedCount": 123,
        "threshold": 123,
        "trippedAt": "2023-11-07T05:31:56Z"
      },
      "circuitBreakerMax": 123,
      "context": {
        "context": {}
      },
      "createdAt": "2023-11-07T05:31:56Z",
      "currentVersion": "<string>",
      "description": "<string>",
      "displayName": "<string>",
      "draftAutomationSteps": [
        {
          "accountLifecycleAction": {
            "accountInContext": {},
            "accountRef": {
              "accountIdCel": "<string>"
            },
            "actionName": "<string>",
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            }
          },
          "callFunction": {
            "args": {},
            "functionId": "<string>"
          },
          "connectorAction": {
            "actionName": "<string>",
            "argsTemplate": {},
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            },
            "resourceTypeId": "<string>"
          },
          "connectorCreateAccount": {
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            },
            "passwordCel": "<string>",
            "userIdCel": "<string>",
            "userProperties": {
              "displayNameCel": "<string>",
              "emailCel": "<string>",
              "profileAttributeCel": "<string>",
              "usernameCel": "<string>"
            }
          },
          "createAccessReview": {
            "accessReviewTemplateCel": "<string>",
            "accessReviewTemplateId": "<string>",
            "campaignName": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "createRevokeTasks": {
            "appEntitlementRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "appEntitlementRefsCel": "<string>",
            "excludedAppEntitlementRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "excludedAppEntitlementRefsCel": "<string>",
            "revokeAll": true,
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "createRevokeTasksV2": {
            "exclusionCriteria": {
              "excludedAppIds": [
                "<string>"
              ],
              "excludedComplianceFrameworkIds": [
                "<string>"
              ],
              "excludedResourceTypeIds": [
                "<string>"
              ],
              "excludedRiskLevelIds": [
                "<string>"
              ]
            },
            "exclusionList": {
              "excludedAppEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "exclusionListCel": {
              "excludedAppEntitlementRefsCel": "<string>"
            },
            "exclusionNone": {},
            "inclusionAccessOnly": {},
            "inclusionAll": {},
            "inclusionCriteria": {
              "appIds": [
                "<string>"
              ],
              "complianceFrameworkIds": [
                "<string>"
              ],
              "resourceTypeIds": [
                "<string>"
              ],
              "riskLevelIds": [
                "<string>"
              ]
            },
            "inclusionList": {
              "appEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "inclusionListCel": {
              "appEntitlementRefsCel": "<string>"
            },
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "evaluateExpressions": {
            "expressions": [
              {
                "expressionCel": "<string>",
                "isSecret": true,
                "key": "<string>"
              }
            ]
          },
          "generatePassword": {
            "passwordPolicyId": "<string>",
            "policy": {
              "customCharacters": "<string>",
              "excludedCharacters": "<string>",
              "maxCharacterCount": 123,
              "minCharacterCount": 123,
              "noRestrictions": true,
              "requireLowercase": true,
              "requireNumbers": true,
              "requireSpecialCharacters": true,
              "requireUppercase": true
            }
          },
          "grantEntitlements": {
            "exclusionCriteria": {
              "excludedAppIds": [
                "<string>"
              ],
              "excludedComplianceFrameworkIds": [
                "<string>"
              ],
              "excludedRiskLevelIds": [
                "<string>"
              ]
            },
            "exclusionList": {
              "excludedAppEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "exclusionListCel": {
              "excludedAppEntitlementRefsCel": "<string>"
            },
            "exclusionNone": {},
            "inclusionCriteria": {
              "appIds": [
                "<string>"
              ],
              "complianceFrameworkIds": [
                "<string>"
              ],
              "riskLevelIds": [
                "<string>"
              ]
            },
            "inclusionList": {
              "appEntitlementRefs": [
                {
                  "appId": "<string>",
                  "id": "<string>"
                }
              ]
            },
            "inclusionListCel": {
              "appEntitlementRefsCel": "<string>"
            },
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "removeFromDelegation": {
            "replacementUserIdCel": "<string>",
            "replacementUserRef": {
              "id": "<string>"
            },
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            }
          },
          "runAutomation": {
            "automationTemplateIdCel": "<string>",
            "automationTemplateRef": {
              "id": "<string>"
            },
            "context": {
              "context": {}
            }
          },
          "sendEmail": {
            "body": "<string>",
            "email": "<string>",
            "emailCel": "<string>",
            "subject": "<string>",
            "title": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "sendSlackMessage": {
            "body": "<string>",
            "channelName": "<string>",
            "channelNameCel": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "setCredential": {
            "accountIdCel": "<string>",
            "connectorRef": {
              "appId": "<string>",
              "id": "<string>"
            },
            "passwordCel": "<string>"
          },
          "skipIfTrueCel": "<string>",
          "stepDisplayName": "<string>",
          "stepName": "<string>",
          "storeCredential": {
            "appIdCel": "<string>",
            "credentialCel": "<string>",
            "expiry": "<string>",
            "labelCel": "<string>",
            "maxViews": 123,
            "recipientCel": "<string>",
            "recipientEmailCel": "<string>",
            "ttl": "<string>"
          },
          "taskAction": {
            "close": {
              "useSubjectUser": true,
              "userIdCel": "<string>",
              "userRef": {
                "id": "<string>"
              }
            },
            "reassign": {
              "assigneeUserIdCel": "<string>",
              "assigneeUserRef": {
                "id": "<string>"
              },
              "subjectUserIdCel": "<string>",
              "subjectUserRef": {
                "id": "<string>"
              },
              "useSubjectUser": true
            },
            "taskTypes": []
          },
          "unenrollFromAllAccessProfiles": {
            "catalogIds": [
              "<string>"
            ],
            "catalogIdsCel": "<string>",
            "useSubjectUser": true,
            "userIdsCel": "<string>",
            "userRefs": [
              {
                "id": "<string>"
              }
            ]
          },
          "updateUser": {
            "useSubjectUser": true,
            "userIdCel": "<string>",
            "userRef": {
              "id": "<string>"
            },
            "userStatusCel": "<string>"
          },
          "waitForDuration": {
            "duration": "<string>"
          },
          "webhook": {
            "payload": {},
            "webhookId": "<string>",
            "webhookIdCel": "<string>"
          }
        }
      ],
      "draftTriggers": [
        {
          "accessConflict": {
            "allConflictMonitors": true,
            "conflictMonitorRefs": {
              "conflictMonitorRefs": [
                {
                  "id": "<string>"
                }
              ]
            }
          },
          "appUserCreated": {
            "appId": "<string>",
            "appIdCel": "<string>",
            "condition": "<string>"
          },
          "appUserUpdated": {
            "appId": "<string>",
            "appIdCel": "<string>",
            "condition": "<string>"
          },
          "grantDeleted": {
            "grantTriggerFilter": {
              "accountFilter": {},
              "grantFilter": {},
              "inclusionAll": {},
              "inclusionCriteria": {
                "appIds": [
                  "<string>"
                ],
                "complianceFrameworkIds": [
                  "<string>"
                ],
                "resourceTypeIds": [
                  "<string>"
                ],
                "riskLevelIds": [
                  "<string>"
                ]
              },
              "inclusionList": {
                "appEntitlementRefs": [
                  {
                    "appId": "<string>",
                    "id": "<string>"
                  }
                ]
              },
              "inclusionListCel": {
                "appEntitlementRefsCel": "<string>"
              }
            }
          },
          "grantFound": {
            "grantTriggerFilter": {
              "accountFilter": {},
              "grantFilter": {},
              "inclusionAll": {},
              "inclusionCriteria": {
                "appIds": [
                  "<string>"
                ],
                "complianceFrameworkIds": [
                  "<string>"
                ],
                "resourceTypeIds": [
                  "<string>"
                ],
                "riskLevelIds": [
                  "<string>"
                ]
              },
              "inclusionList": {
                "appEntitlementRefs": [
                  {
                    "appId": "<string>",
                    "id": "<string>"
                  }
                ]
              },
              "inclusionListCel": {
                "appEntitlementRefsCel": "<string>"
              }
            }
          },
          "schedule": {
            "advanced": true,
            "condition": "<string>",
            "cronSpec": "<string>",
            "skipIfTrueCel": "<string>",
            "start": "2023-11-07T05:31:56Z",
            "timezone": "<string>"
          },
          "scheduleAppUser": {
            "appId": "<string>",
            "condition": "<string>",
            "cronSpec": "<string>",
            "start": "2023-11-07T05:31:56Z",
            "timezone": "<string>"
          },
          "scheduleNoUser": {
            "advanced": true,
            "cronSpec": "<string>",
            "start": "2023-11-07T05:31:56Z",
            "timezone": "<string>"
          },
          "usageBasedRevocation": {
            "appId": "<string>",
            "enabledAt": "2023-11-07T05:31:56Z",
            "excludedGroupRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "excludedUserRefs": [
              {
                "id": "<string>"
              }
            ],
            "includeUsersWithNoActivity": true,
            "runDelayed": {
              "coldStartDelayDays": 123
            },
            "runImmediately": {},
            "targetedAppUserTypes": [],
            "targetedEntitlementRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "unusedForDays": 123
          },
          "userCreated": {
            "condition": "<string>"
          },
          "userProfileChange": {
            "condition": "<string>"
          },
          "webhook": {
            "capabilityUrl": {},
            "hmac": {},
            "jwt": {
              "jwksUrl": "<string>"
            },
            "listenerId": "<string>"
          }
        }
      ],
      "enabled": true,
      "id": "<string>",
      "isDraft": true,
      "lastExecutedAt": "2023-11-07T05:31:56Z",
      "triggers": [
        {
          "accessConflict": {
            "allConflictMonitors": true,
            "conflictMonitorRefs": {
              "conflictMonitorRefs": [
                {
                  "id": "<string>"
                }
              ]
            }
          },
          "appUserCreated": {
            "appId": "<string>",
            "appIdCel": "<string>",
            "condition": "<string>"
          },
          "appUserUpdated": {
            "appId": "<string>",
            "appIdCel": "<string>",
            "condition": "<string>"
          },
          "grantDeleted": {
            "grantTriggerFilter": {
              "accountFilter": {},
              "grantFilter": {},
              "inclusionAll": {},
              "inclusionCriteria": {
                "appIds": [
                  "<string>"
                ],
                "complianceFrameworkIds": [
                  "<string>"
                ],
                "resourceTypeIds": [
                  "<string>"
                ],
                "riskLevelIds": [
                  "<string>"
                ]
              },
              "inclusionList": {
                "appEntitlementRefs": [
                  {
                    "appId": "<string>",
                    "id": "<string>"
                  }
                ]
              },
              "inclusionListCel": {
                "appEntitlementRefsCel": "<string>"
              }
            }
          },
          "grantFound": {
            "grantTriggerFilter": {
              "accountFilter": {},
              "grantFilter": {},
              "inclusionAll": {},
              "inclusionCriteria": {
                "appIds": [
                  "<string>"
                ],
                "complianceFrameworkIds": [
                  "<string>"
                ],
                "resourceTypeIds": [
                  "<string>"
                ],
                "riskLevelIds": [
                  "<string>"
                ]
              },
              "inclusionList": {
                "appEntitlementRefs": [
                  {
                    "appId": "<string>",
                    "id": "<string>"
                  }
                ]
              },
              "inclusionListCel": {
                "appEntitlementRefsCel": "<string>"
              }
            }
          },
          "schedule": {
            "advanced": true,
            "condition": "<string>",
            "cronSpec": "<string>",
            "skipIfTrueCel": "<string>",
            "start": "2023-11-07T05:31:56Z",
            "timezone": "<string>"
          },
          "scheduleAppUser": {
            "appId": "<string>",
            "condition": "<string>",
            "cronSpec": "<string>",
            "start": "2023-11-07T05:31:56Z",
            "timezone": "<string>"
          },
          "scheduleNoUser": {
            "advanced": true,
            "cronSpec": "<string>",
            "start": "2023-11-07T05:31:56Z",
            "timezone": "<string>"
          },
          "usageBasedRevocation": {
            "appId": "<string>",
            "enabledAt": "2023-11-07T05:31:56Z",
            "excludedGroupRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "excludedUserRefs": [
              {
                "id": "<string>"
              }
            ],
            "includeUsersWithNoActivity": true,
            "runDelayed": {
              "coldStartDelayDays": 123
            },
            "runImmediately": {},
            "targetedAppUserTypes": [],
            "targetedEntitlementRefs": [
              {
                "appId": "<string>",
                "id": "<string>"
              }
            ],
            "unusedForDays": 123
          },
          "userCreated": {
            "condition": "<string>"
          },
          "userProfileChange": {
            "condition": "<string>"
          },
          "webhook": {
            "capabilityUrl": {},
            "hmac": {},
            "jwt": {
              "jwksUrl": "<string>"
            },
            "listenerId": "<string>"
          }
        }
      ]
    }
  ],
  "nextPageToken": "<string>"
}

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Authorization
string
header
required

This API uses OAuth2 with the Client Credential flow. Client Credentials must be sent in the BODY, not the headers. For an example of how to implement this, refer to the c1TokenSource.Token() function.

Response

200 - application/json

Successful response

The ListAutomationsResponse message.

list
Automation · object[] | null

The page of automations.

nextPageToken
string | null

Token to retrieve the next page of results, empty when no more results exist.